<?php

namespace Ems\Services;

use Doctrine\ORM\EntityManager;

use Util\Environment;
use Util\DateUtil;

use Ems\Repository\AlteSalarioRepository;
use Ems\Util\{ Utilities, ArrayUtil };

class AlteSalarioService {

    public function __construct(
        AlteSalarioRepository $alteSalarioRepository,
        Environment $environment
    ) {
        $this->alteSalarioRepository         = $alteSalarioRepository;
        $this->environment                  = $environment;
    }



    public function getModalidadeSalarial() {
        $nrorg = $this->environment->getNrorg();
        return $this->alteSalarioRepository->getModalidadeSalarial($nrorg);
    }
    
    public function getTipoAlteraSal() {
        $nrorg = $this->environment->getNrorg();
        return $this->alteSalarioRepository->getTipoAlteraSal($nrorg);
    }
    
    public function getUltimoSalario($nrvinculom) {
        $nrorg = $this->environment->getNrorg();
        list ($dia, $mes, $ano) = explode ('/', date("d/m/Y"));
        $dtmescompetenc = "01/".$mes."/".$ano;
        return $this->alteSalarioRepository->getUltimoSalario($nrorg,$dtmescompetenc,$nrvinculom);
    }

    
}
