/*******************************************************************************************************
  Nome
  7851_PLATRGS_IDENTIFICA_LOGAPROVCARD.SQL

  Descrio
  Inserir na tabela LOGAPROVCARD os parmetros da funo Webtunning
****************************************************************************/
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'IDENTIFICA_LOGAPROVCARD' AND
                TYPE   = 'TR'              AND
                U.UID  = O.UID             AND
                U.NAME = USER)

DROP TRIGGER IDENTIFICA_LOGAPROVCARD
GO

CREATE TRIGGER IDENTIFICA_LOGAPROVCARD
ON LOGAPROVCARD FOR INSERT
AS
BEGIN
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);

   SET @V_DSREMOTEADDR = ' ';
   SET @V_DSREMOTEHOST = ' ';
   SET @V_DSSERVERRDM  = ' ';
   SET @V_DSSERVMETHOD = ' ';
   SET @V_DSREMOTEOPER = ' ';

   SELECT
      @V_DSREMOTEADDR = ISNULL(MAX(DSREMOTEADDR), 'VIA BD'),
      @V_DSREMOTEHOST = ISNULL(MAX(DSREMOTEHOST), 'VIA BD'),
      @V_DSSERVERRDM  = ISNULL(MAX(DSSERVERRDM ), 'VIA BD'),
      @V_DSSERVMETHOD = ISNULL(MAX(DSSERVMETHOD), 'VIA BD'),
      @V_DSREMOTEOPER = ISNULL(MAX(DSREMOTEOPER), 'VIA BD')
   FROM
      SQLWEBTUNNING
   WHERE
      (NRAUDSID = @@SPID) AND
      (CONVERT(VARCHAR, CONVERT(DATETIME, DTSTARTDATE, 103), 103)) = (SELECT MAX(CONVERT(VARCHAR, CONVERT(DATETIME, DTSTARTDATE, 103), 103))
                                                                      FROM SQLWEBTUNNING S
                                                                      WHERE S.NRAUDSID = @@SPID);

   UPDATE LOGAPROVCARD
   SET DSRDMUSUAPROVCARD = @V_DSSERVERRDM,
       DSENDUSUAPROVCARD = @V_DSREMOTEADDR,
       DSNMUSUAPROVCARD  = @V_DSREMOTEHOST,
       DSMETUSUAPROVCARD = @V_DSSERVMETHOD,
       CDORESPAPROVCARD  = @V_DSREMOTEOPER
   FROM INSERTED
   WHERE LOGAPROVCARD.CDFILIAL = INSERTED.CDFILIAL AND
         LOGAPROVCARD.CDSERVFILI = INSERTED.CDSERVFILI AND
         LOGAPROVCARD.DTMESCARDAPROVLOG = INSERTED.DTMESCARDAPROVLOG AND
         LOGAPROVCARD.CDOPERLOGAPROVCARD = INSERTED.CDOPERLOGAPROVCARD AND
         LOGAPROVCARD.DTLOGAPROVCARD = INSERTED.DTLOGAPROVCARD;

END;

GO

-- VERSAO --
EXEC ATUVEROBJ 'IDENTIFICA_LOGAPROVCARD','5.70.000';
GO
